Unit _PTPE;
// code Codage prdictif

(*
 TPE 2001-2002
 DODANE Jean-Baptiste, ROUSSILLON Cyril  TS3
 Lyce Xavier Marmier, PONTARLIER

 Pour toute question, vous pouvez nous contacter :
   Jean-Baptiste (LZW, RLE) : jb@jbdsoftware.fr.st
   Cyril (JPEG, prdictif)  : cyril@crtek.fr.st
   
 Les TPE complets sont disponibles  l'adresse :
   www.chez.com/itek
 Ou sur nos sites personnels :
   www.jbdsoftware.fr.st
   www.crteknologies.fr.st
*)

Interface

Uses
	Windows, Graphics, SysUtils, Dialogs, _Bibliotheque;

	Procedure SauverPTPE(NomFichier: String; Var Img: sImage; Progress: TProgressEvent);
	Procedure ChargerPTPE(NomFichier: String; Var Img: sImage; Progress: TProgressEvent; Fichier: pFichier);

Implementation

Const
	Gd = 256; RLE = 257; RLE2 = 258; zero = 128;

Var
  Arbre: sHuffman;

//---------------------------------------------------------------------------------------------
// Codage prdictif
//---------------------------------------------------------------------------------------------

Procedure Prediction(Var Image: sImage; i, j: Integer; Var Pred: Array Of Integer);
Begin
	If i > 0
  	Then If j > 0
      	Then Begin
        	Pred[0] := Round((GetRValue(Image.Pix[j - 1, i]) + GetRValue(Image.Pix[j, i - 1])) / 2);
        	Pred[1] := Round((GetGValue(Image.Pix[j - 1, i]) + GetGValue(Image.Pix[j, i - 1])) / 2);
        	Pred[2] := Round((GetBValue(Image.Pix[j - 1, i]) + GetBValue(Image.Pix[j, i - 1])) / 2);
      End Else Begin
      	Pred[0] := GetRValue(Image.Pix[j, i - 1]);
       	Pred[1] := GetGValue(Image.Pix[j, i - 1]);
       	Pred[2] := GetBValue(Image.Pix[j, i - 1]);
    End Else If j > 0
    	Then Begin
        Pred[0] := GetRValue(Image.Pix[j - 1, i]);
        Pred[1] := GetGValue(Image.Pix[j - 1, i]);
        Pred[2] := GetBValue(Image.Pix[j - 1, i]);
      End Else Begin Pred[0] := 0; Pred[1] := 0; Pred[2] := 0 End;
End;

//---------------------------------------------------------------------------------------------
// SauverPred
Procedure SauverPTPE(NomFichier: String; Var Img: sImage; Progress: TProgressEvent);
Var
  HandleF, i, j, k, l, m, taille, Adresse, nbZero: Integer;
  Buffer: Array[0..799] Of Byte;
  Couleur: TColor;
  Pred: Array[0..2] Of Integer;
  ActualFreq: Integer;
Begin
	Arbre := sHuffman.Create(259);
  HandleF := FileCreate(NomFichier);
  FileWrite(HandleF, 'PTPE', 4);
  FileWrite(HandleF, Adresse, 4);
  FileWrite(HandleF, Img.Largeur, 4);
  FileWrite(HandleF, Img.Hauteur, 4);
  Adresse := 16;

	For i := 0 To 799 Do Buffer[i] := 0;
  i := 0; j := 0; nbZero := 0; taille := 0; ActualFreq := 5;
  Repeat
    Arbre.Actualiser; k := 1;
    While k <= ActualFreq Do
    Begin
      Prediction(Img, i, j, Pred);
      Couleur := Img.Pix[j, i];
      Pred[0] := GetRValue(Couleur) - Pred[0] + zero;
      Pred[1] := GetGValue(Couleur) - Pred[1] + zero;
      Pred[2] := GetBValue(Couleur) - Pred[2] + zero;

      //--- RLE
      If (Pred[0] = zero) And (Pred[1] = zero) And (Pred[2] = zero) Then
      Begin
      	Inc(nbZero);
        If nbZero >= 4099 Then Begin Arbre.EcrireCar(RLE2, taille, Buffer); EcrireBits(4095, 12, taille, Buffer); nbZero := 0 End;
      End Else Begin Inc(k);
      For l := 0 To 2 Do
      Begin
      	//--- Fin de RLE
				If nbZero > 0 Then
        Begin
        	If nbZero < 3 Then For m := 1 To 3 * nbZero Do Arbre.EcrireCar(zero, taille, Buffer) Else
          If nbZero < 67 Then
          Begin
          	Arbre.EcrireCar(RLE, taille, Buffer);
            EcrireBits(nbZero - 3, 6, taille, Buffer)
          End Else
          Begin
          	Arbre.EcrireCar(RLE2, taille, Buffer);
            EcrireBits(nbZero - 3, 12, taille, Buffer)
          End;
          nbZero := 0;
        End;
	      //--- Dpassement tendue
	    	If (Pred[l] < 0) Or (Pred[l] > (zero * 2) - 1) Then
	      Begin
	      	Arbre.EcrireCar(Gd, taille, Buffer);
	      	Inc(Pred[l], 256 - zero);
	        EcrireBits(Pred[l], 9, taille, Buffer);
	      End Else
	      Arbre.EcrireCar(Pred[l], taille, Buffer);
  		End; End;

     	Inc(j);
      If j >= Img.Largeur Then Begin j := 0; Inc(i); If @Progress <> nil Then Progress(Round(i * 100 / Img.Hauteur)) End;
      If i >= Img.Hauteur Then Break;
    End;
	  FileWrite(HandleF, Buffer, taille Div 8);
    Inc(Adresse, taille Div 8);
    Buffer[0] := Buffer[taille Div 8];
    taille := taille Mod 8;
    If ActualFreq < 80 Then ActualFreq := ActualFreq * 2;
  Until i >= Img.Hauteur;

	If nbZero > 0 Then
   	If nbZero < 3 Then For m := 1 To 3 * nbZero Do Arbre.EcrireCar(zero, taille, Buffer) Else
    If nbZero < 67 Then
	    Begin Arbre.EcrireCar(RLE, taille, Buffer); EcrireBits(nbZero - 3, 6, taille, Buffer) End Else
	    Begin	Arbre.EcrireCar(RLE2, taille, Buffer); EcrireBits(nbZero - 3, 12, taille, Buffer) End;

  If taille Mod 8 <> 0 Then taille := taille Div 8 + 1 Else taille := taille Div 8;
  FileWrite(HandleF, Buffer, taille);
  Inc(Adresse, taille);

  FileSeek(HandleF, 4, 0);
  FileWrite(HandleF, Adresse, 4);
  FileClose(HandleF);
  Arbre.Destroy;
End;


//---------------------------------------------------------------------------------------------
// ChargerPred
Procedure ChargerPTPE(NomFichier: String; Var Img: sImage; Progress: TProgressEvent; Fichier: pFichier);
Var
  HandleF, i, j, k, l, m, taille, Adresse, nbZero, X: Integer;
  Buffer: Array[0..799] Of Byte;
  Pred: Array[0..2] Of Integer;
  ActualFreq: Integer;
Begin
  Img.nbCouleurs := 16777216;
	Arbre := sHuffman.Create(259);
  HandleF := FileOpen(NomFichier, fmOpenRead);
  Try Try
	  FileRead(HandleF, Adresse, 4);
	  If Adresse <> 1162892368 Then Raise Erreur(Erreur);
	  FileRead(HandleF, Adresse, 4);
	  FileRead(HandleF, Img.Largeur, 4);
	  FileRead(HandleF, Img.Hauteur, 4);
 		If Fichier <> nil Then
    Begin
    	Fichier.Nom := ExtractFileName(NomFichier);
		  Fichier.Format := 'Image PTPE (codage prdictif)';
	    Fichier.Taille := Adresse;
	    Fichier.AutreT[0] := 'Taux comp.';
	    Fichier.AutreC[0] := IntToStr(Round(100 - (Adresse - 16) * 100 / (Img.Largeur * Img.Hauteur * 3))) + ' %';
    End;
	  SetLength(Img.Pix, Img.Largeur, Img.Hauteur);
	  Adresse := 16;

	  i := 0; j := 0; nbZero := 0; taille := 0; ActualFreq := 5;
	  Repeat
	    Arbre.Actualiser;
	    FileRead(HandleF, Buffer, 800); k := 1;
	    While k <= ActualFreq Do
	    Begin
	      Prediction(Img, i, j, Pred);
	      m := 0;
	      If nbZero > 0 Then Dec(nbZero) Else Begin Inc(k);
	      For l := 0 To 2 Do
	      Begin
		      X := Arbre.LireCar(taille, Buffer);
		      //--- Dpassement tendue
		      If X = Gd Then
	        Begin
	          Pred[l] := Pred[l] + LireBits(9, taille, Buffer) - 256;
	        //--- RLE
	        End Else If X = RLE Then
	        Begin
	        	nbZero := LireBits(6, taille, Buffer) + 2; Dec(k);
	          Break;
	        End Else If X = RLE2 Then
	        Begin
	        	nbZero := LireBits(12, taille, Buffer) + 2; Dec(k);
	          Break;
	        End Else
	        //--- normal
	        Begin
	        	If X = zero Then Inc(m);
	        	Pred[l] := X + Pred[l] - zero;
	        End;
		    End; End;
	      If m = 3 Then Dec(k);
	      Img.Pix[j, i] := RGB(Pred[0], Pred[1], Pred[2]);

	     	Inc(j);
	      If j >= Img.Largeur Then Begin j := 0; Inc(i); If @Progress <> nil Then Progress(Round(i * 100 / Img.Hauteur)) End;
	      If i >= Img.Hauteur Then Break;
	    End;
	    Inc(Adresse, taille Div 8);
	    FileSeek(HandleF, Adresse, 0);
	    taille := taille Mod 8;
      If ActualFreq < 80 Then ActualFreq := ActualFreq * 2;
	  Until i = Img.Hauteur;
  Except
  	On Erreur Do ShowMessage('Ce n''est pas le bon type de fichier');
    Else ShowMessage('Il s''est produit une erreur');
  End Finally FileClose(HandleF); Arbre.Destroy End;
End;

End.
